minor improvements
[distro-setup] / brc
1 #!/bin/bash
2 # this gets sourced. shebang is just for file mode detection
3
4 # note, to catch errors in functions but not outside, do:
5 # set -E -o pipefail
6 # trap return ERR
7 # trap 'trap ERR' RETURN
8
9
10 # * settings
11
12 CDPATH=.
13
14 set -o pipefail
15
16 # remove all aliases. aliases provided by the system tend to get in the way,
17 # for example, error happens if I try to define a function the same name as an alias
18 unalias -a
19
20 # remove gnome keyring warning messages
21 # there is probably a more proper way, but I didnt find any easily on google
22 # now using xfce+xmonad instead of vanilla xmonad, so disabling this
23 #unset GNOME_KEYRING_CONTROL
24
25 # use extra globing features.
26 shopt -s extglob
27 # include .files when globbing, but ignore files name . and ..
28 # setting this also sets dotglob.
29 # Note, this doesnt work in bash 4.4 anymore, for paths with
30 # more than 1 directory, like a/b/.foo, since * is fixed to not match /
31 export GLOBIGNORE=*/.:*/..
32
33 # broken with bash_completion package. Saw a bug for this once. dont anymore.
34 # still broken in wheezy
35 # still buggered in latest stable from the web, version 2.1
36 # perhaps its fixed in newer git version, which fails to make for me
37 # this note is from 6-2014.
38 # Also, enabling this before sourcing .bashrc makes PATH be empty.
39 #shopt -s nullglob
40
41 # make tab on an empty line do nothing
42 shopt -s no_empty_cmd_completion
43
44 # advanced completion
45 # http://bash-completion.alioth.debian.org/
46 # might be sourced by the system already, but ive noticed it not being sourced before
47 if ! type _init_completion &> /dev/null && [[ -r "/usr/share/bash-completion/bash_completion" ]]; then
48 . /usr/share/bash-completion/bash_completion
49 fi
50
51
52 # fix spelling errors for cd, only in interactive shell
53 shopt -s cdspell
54 # append history instead of overwritting it
55 shopt -s histappend
56 # for compatibility, per gentoo/debian bashrc
57 shopt -s checkwinsize
58 # attempt to save multiline single commands as single history entries.
59 shopt -s cmdhist
60 # enable **
61 shopt -s globstar
62
63
64 # inside emcas fixes
65 if [[ $RLC_INSIDE_EMACS ]]; then
66 # EMACS is used by bash on startup, but we dont need it anymore.
67 # plus I hit a bug in a makefile which inherited it
68 unset EMACS
69 export RLC_INSIDE_EMACS
70 export PAGER=cat
71 export MANPAGER=cat
72 # scp completion does not work, but this doesnt fix it. todo, figure this out
73 complete -r scp &> /dev/null
74 # todo, remote file completion fails, figure out how to turn it off
75 export NODE_DISABLE_COLORS=1
76 # This gets rid of ugly terminal escape chars in node repl
77 # sometime, Id like to have completion working in emacs shell for node
78 # the offending chars can be found in lib/readline.js,
79 # things that do like:
80 # stream.write('\x1b[' + (x + 1) + 'G');
81 # We can remove them and keep readline, for example by doing this
82 # to start a repl:
83 #!/usr/bin/env nodejs
84 # var readline = require('readline');
85 # readline.cursorTo = function(a,b,c) {};
86 # readline.clearScreenDown = function(a) {};
87 # const repl = require('repl');
88 # var replServer = repl.start('');
89 #
90 # no prompt, or else readline complete seems to be confused, based
91 # on our column being different? node probably needs to send
92 # different kind of escape sequence that is not ugly. Anyways,
93 # completion doesnt work yet even with the ugly prompt, so whatever
94 #
95 export NODE_NO_READLINE=1
96
97 fi
98
99
100 if [[ $- == *i* ]]; then
101 # for readline-complete.el
102 if [[ $RLC_INSIDE_EMACS ]]; then
103 # all for readline-complete.el
104 stty echo
105 bind 'set horizontal-scroll-mode on'
106 bind 'set print-completions-horizontally on'
107 bind '"\C-i": self-insert'
108 else
109
110 # todo: not sure this works in sakura
111 #stty werase undef
112 #bind "\C-w": kill-region
113 # sakura == xterm-256color
114 # konsole == xterm
115 if [[ $TERM == "xterm" ]]; then
116 # control + arrow keys. for other terminals, see http://unix.stackexchange.com/questions/10806/how-to-change-previous-next-word-shortcut-in-bash
117 bind '"\e[1;5C": shell-forward-word' 2>/dev/null
118 bind '"\e[1;5D": shell-backward-word' 2>/dev/null
119 else
120 # make ctrl-backspace work. for konsole, i fixed it through
121 # /home/iank/.local/share/konsole/default.keytab
122 stty werase '^h'
123 bind '"\eOc": shell-forward-word'
124 bind '"\eOd": shell-backward-word'
125 fi
126 # i cant remember why i did this, probably to free up some keys to bind
127 # to other things in bash.
128 # other than C-c and C-z, the rest defined by stty -a are, at least in
129 # gnome-terminal, overridden by bash, or disabled by the system
130 stty lnext undef stop undef start undef
131 fi
132
133 fi
134
135
136 # history number. History expansion is good.
137 PS4='$LINENO+ '
138 # history file size limit, set to unlimited.
139 # this needs to be different from the default because
140 # default HISTFILESIZE is 500 and could clobber our history
141 HISTFILESIZE=
142 # max commands 1 session can append/read from history
143 HISTSIZE=100000
144 # my own history size limit based on lines
145 HISTFILELINES=1000000
146 HISTFILE=$HOME/.bh
147 # the time format display when doing the history command
148 # also, setting this makes the history file record time
149 # of each command as seconds from the epoch
150 HISTTIMEFORMAT="%Y-%m-%d %I:%M %p "
151 # consecutive duplicate lines dont go in history
152 HISTCONTROL=ignoredups
153 # works in addition to HISTCONTROL to do more flexible things
154 # it could also do the same things as HISTCONTROL and thus replace it,
155 # but meh. dunno why, but just " *" does glob expansion, so use [ ] to avoid it.
156 HISTIGNORE='pass *:[ ]*:lom*:gram*'
157
158 export BC_LINE_LENGTH=0
159
160
161 # note, if I use a machine I dont want files readable by all users, set
162 # umask 077 # If fewer than 4 digits are entered, leading zeros are assumed
163
164 C_DEFAULT_DIR=/a
165
166 # i for insensitive. the rest from
167 # https://superuser.com/questions/366930/how-do-i-get-the-git-pager-to-clean-up-screen-output-after-exit
168 # and reading the man
169 export LESS=RXi
170 export SYSTEMD_LESS=$LESS
171
172 # * include files
173 for _x in /a/bin/distro-functions/src/* /a/bin/!(githtml)/*-function?(s); do
174 source "$_x"
175 done
176 unset _x
177 # so I can share my bashrc
178 for x in /a/bin/bash_unpublished/source-!(.#*); do source $x; done
179 source $(dirname $(readlink -f $BASH_SOURCE))/path_add-function
180 source /a/bin/log-quiet/logq-function
181 if [[ -e /a/bin/errhandle/err ]]; then
182 source /a/bin/errhandle/err
183 err-allow
184 fi
185 # if someone exported $SOE (stop on error), catch errors
186 if [[ $SOE ]]; then
187 err-catch
188 fi
189
190 path_add /a/exe
191 # end just because it seems safer
192 path_add --end node_modules/.bin
193 # pip3 --user things go here:
194 path_add --end ~/.local/bin
195 path_add --ifexists --end /a/work/libremanage
196 path_add --ifexists --end /a/opt/adt-bundle*/tools /a/opt/adt-bundle*/platform-tools
197 path_add --ifexists --end /a/opt/scancode-toolkit-2.9.2
198 export WCDHOME=/a
199 # based on readme.debian. dunno if this will break on other distros.
200 _x=/usr/share/wcd/wcd-include.sh
201 if [[ -e $_x ]]; then source $_x; fi
202
203
204 # * aliases
205
206 # very few aliases, functions are always preferred.
207
208 # ancient stuff.
209 if [[ $OS == Windows_NT ]]; then
210 alias ffs='cygstart "/c/Program Files (x86)/Mozilla Firefox/firefox.exe" -P scratch'
211 export DISPLAY=nt
212 alias j='command cygpath'
213 alias t='command cygstart'
214 alias cygstart='echo be quick, use the alias "t" instead :\)'
215 alias cygpath='echo be quick, use the alias "j" instead :\)'
216 fi
217
218
219
220 # keep this in mind? good for safety.
221 # alias cp='cp -i'
222 # alias mv='mv -i'
223
224
225 # remove any default aliases for these
226 unalias ls ll grep &>/dev/null ||:
227
228
229
230 # * functions
231
232
233 ..() { c ..; }
234 ...() { c ../..; }
235 ....() { c ../../..; }
236 .....() { c ../../../..; }
237 ......() { c ../../../../..; }
238
239
240 # file cut copy and paste, like the text buffers :)
241 # I havnt tested these.
242 _fbufferinit() { # internal use by
243 ! [[ $my_f_tempdir ]] && my_f_tempdir=$(mktemp -d)
244 rm -rf "$my_f_tempdir"/*
245 }
246 fcp() { # file cp
247 _fbufferinit
248 cp "$@" "$my_f_tempdir"/
249 }
250 fct() { # file cut
251 _fbufferinit
252 mv "$@" "$my_f_tempdir"/
253 }
254 fpst() { # file paste
255 [[ $2 ]] && { echo too many arguments; return 1; }
256 target=${1:-.}
257 cp "$my_f_tempdir"/* "$target"
258 }
259
260
261 # todo, update this
262 complete -F _longopt la lower low rlt rld rl lld ts ll dircp ex fcp fct fpst gr
263
264
265 _cdiff-prep() {
266 # join options which are continued to multiples lines onto one line
267 local first=true
268 grep -vE '^([ \t]*#|^[ \t]*$)' "$1" | while IFS= read -r line; do
269 # remove leading spaces/tabs. assumes extglob
270 if [[ $line == "[ ]*" ]]; then
271 line="${line##+( )}"
272 fi
273 if $first; then
274 pastline="$line"
275 first=false
276 elif [[ $line == *=* ]]; then
277 echo "$pastline" >> "$2"
278 pastline="$line"
279 else
280 pastline="$pastline $line"
281 fi
282 done
283 echo "$pastline" >> "$2"
284 }
285
286 _khfix_common() {
287 local host=${1##*@}
288 local ip port
289 read -r ip port < <(timeout 1 ssh -oBatchMode=yes -oControlMaster=no -oControlPath=/ -v $1 |& sed -rn "s/debug1: Connecting to $host \[([^\]*)] port ([0-9]+).*/\1 \2/p")
290 if [[ ! $ip ]]; then
291 echo "khfix: ssh failed"
292 return 1
293 fi
294 if [[ $port != 22 ]]; then
295 ip_entry="[$ip]:$port"
296 host_entry="[$host]:$port"
297 else
298 ip_entry=$ip
299 host_entry=$host
300 fi
301 ssh-keygen -R "$host_entry" -f $(readlink -f ~/.ssh/known_hosts)
302 echo "khfix: removing key for $ip_entry"
303 ssh-keygen -R "$ip_entry" -f $(readlink -f ~/.ssh/known_hosts)
304 }
305 khfix() { # known hosts fix
306 _khfix_common "$@" || return 1
307 ssh $1 :
308 }
309 khcopy() {
310 _khfix_common "$@"
311 ssh-copy-id $1
312 }
313
314 a() {
315 local x=$(readlink -nf "$@")
316 # yes, its kinda dumb that xclip/xsel cant do this in one invocation
317 echo -n "$x" | xclip -selection clipboard
318 echo -n "$x" | xclip
319 }
320
321 ack() { ack-grep "$@"; }
322
323 anki() {
324 if which anki &>/dev/null; then
325 command anki
326 else
327 schroot -c anki -- anki
328 fi
329 }
330
331 astudio() {
332 # googling android emulator libGL error: failed to load driver: r600
333 # lead to http://stackoverflow.com/a/36625175/14456
334 export ANDROID_EMULATOR_USE_SYSTEM_LIBS=1
335 /a/opt/android-studio/bin/studio.sh "$@" &r;
336 }
337
338 b() {
339 # backwards
340 c -
341 }
342
343 bbk() {
344 c /
345 # run latest
346 install-my-scripts
347 btrbk-run "$@"
348 }
349
350 bfg() { java -jar /a/opt/bfg-1.12.14.jar "$@"; }
351
352 bigclock() {
353 xclock -digital -update 1 -face 'arial black-80:bold'
354 }
355
356 bpush() {
357 case $HOSTNAME in
358 tp) target=x2 ;;
359 x2) target=tp ;;
360 esac
361 btrbk-run -t $target && switch-mail-host $HOSTNAME $target
362 }
363 bpull() {
364 case $HOSTNAME in
365 tp) source=x2 ;;
366 x2) source=tp ;;
367 esac
368 btrbk-run -s $source && switch-mail-host $source $HOSTNAME
369 }
370
371 btc() {
372 local f=/etc/bitcoin/bitcoin.conf
373 # importprivkey will timeout if using the default of 15 mins.
374 # upped it to 1 hour.
375 bitcoin-cli -rpcclienttimeout=60000 -$(s grep rpcuser= $f) -$(s grep rpcpassword= $f) "$@"
376 }
377
378 btcusd() { # $1 btc in usd
379 local price
380 price="$(curl -s https://api.coinbase.com/v2/prices/BTC-USD/spot | jq -r .data.amount)"
381 printf "$%s\n" "$price"
382 if [[ $1 ]]; then
383 printf "$%.2f\n" "$(echo "scale=4; $price * $1"| bc -l)"
384 fi
385 }
386 usdbtc() { # $1 usd in btc
387 local price
388 price="$(curl -s https://api.coinbase.com/v2/prices/BTC-USD/spot | jq -r .data.amount)"
389 printf "$%s\n" "$price"
390 if [[ $1 ]]; then
391 # 100 mil satoshi / btc. 8 digits after the 1.
392 printf "%.8f btc\n" "$(echo "scale=10; $1 / $price "| bc -l)"
393 fi
394 }
395 satoshi() { # $1 satoshi in usd
396 local price
397 price="$(curl -s https://api.coinbase.com/v2/prices/BTC-USD/spot | jq -r .data.amount)"
398 price=$(echo "scale=10; $price * 0.00000001"| bc -l)
399 printf "$%f\n" "$price"
400 if [[ $1 ]]; then
401 printf "$%.2f\n" "$(echo "scale=10; $price * $1"| bc -l)"
402 fi
403 }
404
405
406 # c. better cd
407 if [[ $RLC_INSIDE_EMACS ]]; then
408 c() { wcd -c -z 50 -o "$@"; }
409 else
410 # lets see what the fancy terminal does from time to time
411 c() { wcd -c -z 50 "$@"; }
412 fi
413
414 caa() { git commit --amend --no-edit -a; }
415
416 caf() {
417 find -L $1 -type f -not \( -name .svn -prune -o -name .git -prune \
418 -o -name .hg -prune -o -name .editor-backups -prune \
419 -o -name .undo-tree-history -prune \) \
420 -exec bash -lc 'hr; echo "$1"; hr; cat "$1"' _ {} \; 2>/dev/null
421
422 }
423
424 calc() { echo "scale=3; $*" | bc -l; }
425 # no having to type quotes, but also no command history:
426 clc() {
427 local x
428 read -r x
429 echo "scale=3; $x" | bc -l
430 }
431
432 cam() {
433 git commit -am "$*"
434 }
435
436 cbfstool () { /a/opt/coreboot/build/cbfstool "$@"; }
437
438 ccat () { # config cat. see a config without extra lines.
439 grep '^\s*[^;[:space:]#]' "$@"
440 }
441
442 cdiff() {
443 # diff config files,
444 # setup for format of postfix, eg:
445 # option = stuff[,]
446 # [more stuff]
447 local pastline
448 local unified="$(mktemp)"
449 local f1="$(mktemp)"
450 local f2="$(mktemp)"
451 _cdiff-prep "$1" "$f1"
452 _cdiff-prep "$2" "$f2"
453 cat "$f1" "$f2" | grep -Po '^[^=]+=' | sort | uniq > "$unified"
454 while IFS= read -r line; do
455 # the default bright red / blue doesnt work in emacs shell
456 dwdiff -cblue,red -A best -d " ," <(grep "^$line" "$f1" || echo ) <(grep "^$line" "$f2" || echo ) | colordiff
457 done < "$unified"
458 }
459
460 cgpl()
461 {
462 if (($#)); then
463 cp /a/bin/data/COPYING "$@"
464 else
465 cp /a/bin/data/COPYING .
466 fi
467 }
468
469 capache()
470 {
471 if (($#)); then
472 cp /a/bin/data/LICENSE "$@"
473 else
474 cp /a/bin/data/LICENSE .
475 fi
476 }
477
478 cat-new-files() {
479 local start=$SECONDS
480 local dir="$1"
481 inotifywait -m "$dir" -e create -e moved_to |
482 while read filedir _ file; do
483 cat "$filedir$file"
484 hr
485 calc $((SECONDS - start)) / 60
486 sleep 5
487 done
488
489 }
490
491 chown() {
492 # makes it so chown -R symlink affects the symlink and its target.
493 if [[ $1 == -R ]]; then
494 shift
495 command chown -h "$@"
496 command chown -R "$@"
497 else
498 command chown "$@"
499 fi
500 }
501
502 cim() {
503 git commit -m "$*"
504 }
505
506 cl() {
507 # choose recent directory. cl = cd list
508 c =
509 }
510
511 chrome() {
512 if type -p chromium &>/dev/null; then
513 cmd=chromium
514 else
515 cd
516 cmd="schroot -c stretch chromium"
517 CHROMIUM_FLAGS='--enable-remote-extensions' $cmd &r
518 fi
519 }
520
521 d() { builtin bg; }
522 complete -A stopped -P '"%' -S '"' d
523
524 dat() { # do all tee, for more complex scripts
525 tee >(ssh frodo bash -l) >(bash -l) >(ssh x2 bash -l) >(ssh tp bash -l)
526 }
527 da() { # do all
528 local host
529 "$@"
530 for host in x2 tp kd; do
531 ssh $host "$@"
532 done
533 }
534
535 dc() {
536 diff --strip-trailing-cr -w "$@" # diff content
537 }
538
539 debian_pick_mirror () {
540 # netselect-apt finds a fast mirror.
541 # but we need to replace the mirrors ourselves,
542 # because it doesnt do that. best it can do is
543 # output a basic sources file
544 # here we get the server it found, get the main server we use
545 # then substitute all instances of one for the other in the sources file
546 # and backup original to /etc/apt/sources.list-original.
547 # this is idempotent. the only way to identify debian sources is to
548 # note the original server, so we put it in a comment so we can
549 # identify it later.
550 local file=$(mktemp -d)/f # safe way to get file name without creating one
551 sudo netselect-apt -o "$file" || return 1
552 url=$(grep ^\\w $file | head -n1 | awk '{print $2}')
553 sudo cp -f /etc/apt/sources.list /etc/apt/sources.list-original
554 sudo sed -ri "/http.us.debian.org/ s@( *[^ #]+ +)[^ ]+([^#]+).*@\1$url\2# http.us.debian.org@" /etc/apt/sources.list
555 sudo apt-get update
556 }
557
558 despace() {
559 local x y
560 for x in "$@"; do
561 y="${x// /_}"
562 safe_rename "$x" "$y"
563 done
564 }
565
566 dt() {
567 date "+%A, %B %d, %r" "$@"
568 }
569
570 dus() { # du, sorted, default arg of
571 du -sh ${@:-*} | sort -h
572 }
573
574
575
576 e() { echo "$@"; }
577
578
579 ediff() {
580 [[ ${#@} == 2 ]] || { echo "error: ediff requires 2 arguments"; return 1; }
581 emacs --eval "(ediff-files \"$1\" \"$2\")"
582 }
583
584
585 envload() { # load environment from a previous: export > file
586 local file=${1:-$HOME/.${USER}_env}
587 eval "$(export | sed 's/^declare -x/export -n/')"
588 while IFS= read -r line; do
589 # declare -x makes variables local to a function
590 eval ${line/#declare -x/export}
591 done < "$file"
592 }
593
594 # mail related
595 etail() {
596 sudo tail -f /var/log/exim4/mainlog
597 }
598
599 f() {
600 # cd forward
601 c +
602 }
603
604 fa() {
605 # find array. make an array of file names found by find into $x
606 # argument: find arguments
607 # return: find results in an array $x
608 while read -rd ''; do
609 x+=("$REPLY");
610 done < <(find "$@" -print0);
611 }
612
613 faf() { # find all files
614 find -L $1 -not \( -name .svn -prune -o -name .git -prune \
615 -o -name .hg -prune -o -name .editor-backups -prune \
616 -o -name .undo-tree-history -prune \) 2>/dev/null
617 }
618
619 # one that comes with distros is too old for newer devices
620 fastboot() {
621 /a/opt/android-platform-tools/fastboot "$@";
622 }
623
624 kdecd() { /usr/lib/x86_64-linux-gnu/libexec/kdeconnectd; }
625
626 # List of apps to install/update
627 # Create from existing manually installed apps by doing
628 # fdroidcl update
629 # fdroidcl search -i, then manually removing
630 # automatically installed/preinstalled apps
631
632 #
633 # # my attempt at recovering from boot loop:
634 # # in that case, boot to recovery (volume up, home button, power, let go of power after samsun logo)
635 # # then
636 # mount /dev/block/mmcblk0p12 /data
637 # cd /data
638 # find -iname '*appname*'
639 # rm -rf FOUND_DIRS
640 # usually good enough to just rm -rf /data/app/APPNAME
641 #
642 # currently broken:
643 # # causes replicant to crash
644 # org.quantumbadger.redreader
645 # org.kde.kdeconnect_tp
646
647 # not broke, but wont work without gps
648 #com.zoffcc.applications.zanavi
649 # not broke, but not using atm
650 #com.nutomic.syncthingandroid
651 # # doesn\'t work on replicant
652 #net.sourceforge.opencamera
653 #
654 fdroid_pkgs=(
655 de.marmaro.krt.ffupdater
656 me.ccrama.redditslide
657 org.fedorahosted.freeotp
658 at.bitfire.davdroid
659 com.alaskalinuxuser.justnotes
660 com.artifex.mupdf.viewer.app
661 com.danielkim.soundrecorder
662 com.fsck.k9
663 com.ghostsq.commander
664 com.ichi2.anki
665 com.jmstudios.redmoon
666 com.jmstudios.chibe
667 org.kde.kdeconnect_tp
668 com.notecryptpro
669 com.termux
670 cz.martykan.forecastie
671 de.danoeh.antennapod
672 de.blinkt.openvpn
673 de.marmaro.krt.ffupdater
674 eu.siacs.conversations
675 free.rm.skytube.oss
676 im.vector.alpha # riot
677 info.papdt.blackblub
678 me.tripsit.tripmobile
679 net.gaast.giggity
680 net.minetest.minetest
681 net.osmand.plus
682 org.isoron.uhabits
683 org.linphone
684 org.gnu.icecat
685 org.smssecure.smssecure
686 org.yaaic
687 sh.ftp.rocketninelabs.meditationassistant.opensource
688 )
689 # https://forum.xda-developers.com/android/software-hacking/wip-selinux-capable-superuser-t3216394
690 # for maru,
691 #me.phh.superuser
692
693 fdup() {
694 local -A installed updated
695 local p
696 fdroidcl update
697 if fdroidcl search -u | grep ^org.fdroid.fdroid; then
698 fdroidcl upgrade org.fdroid.fdroid
699 sleep 5
700 fdroidcl update
701 fi
702 for p in $(fdroidcl search -i| grep -o "^\S\+"); do
703 installed[$p]=true
704 done
705 for p in $(fdroidcl search -u| grep -o "^\S\+"); do
706 updated[$p]=false
707 done
708 for p in ${fdroid_pkgs[@]}; do
709 if ! ${installed[$p]:-false}; then
710 fdroidcl install $p
711 # sleeps are just me being paranoid since replicant has a history of crashing when certain apps are installed
712 sleep 5
713 fi
714 done
715 for p in ${!installed[@]}; do
716 if ! ${updated[$p]:-true}; then
717 fdroidcl upgrade $p
718 sleep 5
719 fi
720 done
721 }
722
723 firefox-default-profile() {
724 key=Default value=1 section=$1
725 file=/p/c/subdir_files/.mozilla/firefox/profiles.ini
726 sed -ri "/^ *$key/d" "$file"
727 sed -ri "/ *\[$section\]/,/^ *\[[^]]+\]/{/^\s*$key[[:space:]=]/d};/ *\[$section\]/a $key=$value" "$file"
728 }
729 fdhome() { #firefox default home profile
730 firefox-default-profile Profile0
731 }
732
733 fdwork() {
734 firefox-default-profile Profile4
735 }
736
737 ff() {
738 if type -P firefox &>/dev/null; then
739 firefox "$@"
740 else
741 iceweasel "$@"
742 fi
743 }
744
745
746
747 fn() {
748 firefox -P alt "$@" >/dev/null 2>&1
749 }
750
751
752 fsdiff () {
753 local missing=false
754 local dname="${PWD##*/}"
755 local m="/a/tmp/$dname-missing"
756 local d="/a/tmp/$dname-diff"
757 [[ -e $d ]] && rm "$d"
758 [[ -e $m ]] && rm "$m"
759 local msize=0
760 local fsfile
761 while read -r line; do
762 fsfile="$1${line#.}"
763 if [[ -e "$fsfile" ]]; then
764 md5diff "$line" "$fsfile" && tee -a "/a/tmp/$dname-diff" <<< "$fsfile $line"
765 else
766 missing=true
767 echo "$line" >> "$m"
768 msize=$((msize + 1))
769 fi
770 done < <(find -type f )
771 if $missing; then
772 echo "$m"
773 (( msize <= 100 )) && cat $m
774 fi
775 }
776 fsdiff-test() {
777 # expected output, with different tmp dirs
778 # /tmp/tmp.HDPbwMqdC9/c/d ./c/d
779 # /a/tmp/tmp.qLDkYxBYPM-missing
780 # ./b
781 cd $(mktemp -d)
782 echo ok > a
783 echo nok > b
784 mkdir c
785 echo ok > c/d
786 local x=$(mktemp -d)
787 mkdir $x/c
788 echo different > $x/c/d
789 echo ok > $x/a
790 fsdiff $x
791 }
792 rename-test() {
793 # test whether missing files were renamed, generally for use with fsdiff
794 # $1 = fsdiff output file, $2 = directory to compare to. pwd = fsdiff dir
795 # echos non-renamed files
796 local x y found
797 unset sums
798 for x in "$2"/*; do
799 { sums+=( "$(md5sum < "$x")" ) ; } 2>/dev/null
800 done
801 while read -r line; do
802 { missing_sum=$(md5sum < "$line") ; } 2>/dev/null
803 renamed=false
804 for x in "${sums[@]}"; do
805 if [[ $missing_sum == "$x" ]]; then
806 renamed=true
807 break
808 fi
809 done
810 $renamed || echo "$line"
811 done < "$1"
812 return 0
813 }
814
815 feh() {
816 # F = fullscren, z = random, Z = auto zoom
817 command feh -FzZ "$@"
818 }
819
820 # mail related
821 frozen() {
822 rm -rf /tmp/frozen
823 s mailq |gr frozen|awk '{print $3}' | while read -r id; do
824 s exim -Mvl $id
825 echo
826 s exim -Mvh $id
827 echo
828 s exim -Mvb $id
829 echo -e '\n\n##############################\n'
830 done | tee -a /tmp/frozen
831 }
832 frozenrm() {
833 local ids=()
834 while read -r line; do
835 printf '%s\n' "$line"
836 ids+=($(printf '%s\n' "$line" |gr frozen|awk '{print $3}'))
837 done < <(s mailq)
838 echo "sleeping for 2 in case you change your mind"
839 sleep 2
840 s exim -Mrm "${ids[@]}"
841 }
842
843 funce() {
844 # like -e for functions. returns on error.
845 # at the end of the function, disable with:
846 # trap ERR
847 trap 'echo "${BASH_COMMAND:+BASH_COMMAND=\"$BASH_COMMAND\" }
848 ${FUNCNAME:+FUNCNAME=\"$FUNCNAME\" }${LINENO:+LINENO=\"$LINENO\" }\$?=$?"
849 trap ERR
850 return' ERR
851 }
852
853
854 fw() {
855 firefox -P default "$@" >/dev/null 2>&1
856 }
857
858 getdir () {
859 local help="Usage: getdir [--help] PATH
860 Output the directory of PATH, or just PATH if it is a directory."
861 if [[ $1 == --help ]]; then
862 echo "$help"
863 return 0
864 fi
865 if [[ $# -ne 1 ]]; then
866 echo "getdir error: expected 1 argument, got $#"
867 return 1
868 fi
869 if [[ -d $1 ]]; then
870 echo "$1"
871 else
872 local dir="$(dirname "$1")"
873 if [[ -d $dir ]]; then
874 echo "$dir"
875 else
876 echo "getdir error: directory does not exist"
877 return 1
878 fi
879 fi
880 }
881
882 git_empty_branch() { # start an empty git branch. carefull, it deletes untracked files.
883 [[ $# == 1 ]] || { echo 'need a branch name!'; return 1;}
884 local gitroot
885 gitroot || return 1 # function to set gitroot
886 builtin cd "$gitroot"
887 git symbolic-ref HEAD refs/heads/$1
888 rm .git/index
889 git clean -fdx
890 }
891
892 gitroot() {
893 local help="Usage: gitroot [--help]
894 Print the full path to the root of the current git repo
895
896 Handles being within a .git directory, unlike git rev-parse --show-toplevel,
897 and works in older versions of git which did not have that."
898 if [[ $1 == --help ]]; then
899 echo "$help"
900 return
901 fi
902 local p=$(git rev-parse --git-dir) || { echo "error: not in a git repo" ; return 1; }
903 [[ $p != /* ]] && p=$PWD
904 echo "${p%%/.git}"
905 }
906
907 gitian() {
908 git config user.email ian@iankelling.org
909 }
910
911 gh() {
912 # i got an error, gh not found when doing a pull request, it seems like it wants itself in it\'s path.
913 local _oldpath="$PATH"
914 PATH="$PATH:~/node_modules/.bin"
915 command gh "$@"
916 PATH="$_oldpath"
917 }
918
919 gmacs() {
920 # quit will prompt if the program crashes.
921 gdb -ex=r -ex=quit --args emacs "$@"; r;
922 }
923
924 gdkill() {
925 # kill the emacs daemon
926 pk1 emacs --daemon
927 }
928
929 # at least in flidas, things rely on gpg being gpg1
930 gpg() {
931 command gpg2 "$@"
932 }
933
934 gse() {
935 git send-email --notes '--envelope-sender=<ian@iankelling.org>' \
936 --suppress-cc=self "$@"
937 }
938
939 gr() {
940 grep -iIP --color=auto "$@"
941 }
942
943 grr() { # grep recursive
944 if [[ ${#@} == 1 ]]; then
945 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -RiIP --color=auto "$@" .
946 else
947 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -RiIP --color=auto "$@"
948 fi
949 }
950
951 hstatus() {
952 # do git status on published repos
953 cd /a/bin/githtml
954 do_hr=false
955 for x in *; do
956 cd `readlink -f $x`/..
957 status=$(i status -s) || pwd
958 if [[ $status ]]; then
959 hr
960 echo $x
961 printf "%s\n" "$status"
962 fi
963 cd /a/bin/githtml
964 done
965 }
966
967 hl() { # history limit. Write extra history to archive file.
968 # todo: this is not working or not used currently
969 local max_lines linecount tempfile prune_lines x
970 local harchive="${HISTFILE}_archive"
971 for x in "$HISTFILE" "$harchive"; do
972 [[ -e $x ]] || { touch "$x" && echo "notice from hl(): creating $x"; }
973 if [[ ! $x || ! -e $x || ! -w $x || $(stat -c "%u" "$x") != $EUID ]]; then
974 echo "error in hl: history file \$x:$x no good"
975 return 1
976 fi
977 done
978 history -a # save history
979 max_lines=$HISTFILELINES
980 [[ $max_lines =~ ^[0-9]+$ ]] || { echo "error in hl: failed to get max line count"; return 1; }
981 linecount=$(wc -l < $HISTFILE) # pipe so it doesnt output a filename
982 [[ $linecount =~ ^[0-9]+$ ]] || { echo "error in hl: wc failed"; return 1; }
983 if (($linecount > $max_lines)); then
984 prune_lines=$(($linecount - $max_lines))
985 head -n $prune_lines "$HISTFILE" >> "$harchive" \
986 && sed --follow-symlinks -ie "1,${prune_lines}d" $HISTFILE
987 fi
988 }
989
990 hr() { # horizontal row. used to break up output
991 printf "$(tput setaf 5)â–ˆ$(tput sgr0)%.0s" $(seq ${COLUMNS:-60})
992 echo
993 }
994
995 hrcat() { local f; for f; do [[ -f $f ]] || continue; hr; echo "$f"; cat "$f"; done }
996
997 # get latest hub and run it
998 # main command to use:
999 # hub pull-request --no-edit
1000 # --no-edit means to use the first commit\'s message as the pull request message.
1001 # Also, you need to use a feature branch, not master in your fork.
1002 # On first use, you input username/pass and it gets an oath token so you dont have to repeat
1003 # it\'s at ~/.config/hub
1004 hub() {
1005 local up uptar updir p
1006 p=/github/hub/releases/
1007 up=https://github.com/$(curl -s https://github.com$p| grep -o $p'download/[^/]*/hub-linux-amd64[^"]*' | head -n1)
1008 uptar=${up##*/}
1009 updir=${uptar%.tgz}
1010 if [[ ! -e /a/opt/$updir ]]; then
1011 rm -rf /a/opt/hub-linux-amd64*
1012 wget -P /a/opt $up
1013 tar -C /a/opt -zxf /a/opt/$uptar
1014 rm -f /a/opt/$uptar
1015 s /a/opt/$updir/install
1016 fi
1017
1018 # save token across computers
1019 if [[ ! -L ~/.config/hub ]]; then
1020 if [[ -e ~/.config/hub ]]; then
1021 mv ~/.config/hub /p/c/subdir_files/.config/
1022 fi
1023 if [[ -e /p/c/subdir_files/.config/hub ]]; then
1024 conflink
1025 fi
1026 fi
1027 command hub "$@"
1028 }
1029
1030 i() { git "$@"; }
1031 # modified from ~/local/bin/git-completion.bash
1032 # other completion commands are mostly taken from bash_completion package
1033 complete -o bashdefault -o default -o nospace -F _git i 2>/dev/null \
1034 || complete -o default -o nospace -F _git i
1035
1036 if ! type service &>/dev/null; then
1037 service() {
1038 echo actually running: systemctl $2 $1
1039 systemctl $2 $1
1040 }
1041 fi
1042
1043 ic() {
1044 # fast commit all
1045 git commit -am "$*"
1046 }
1047
1048
1049 idea() {
1050 /a/opt/idea-IC-163.7743.44/bin/idea.sh "$@" &r
1051 }
1052
1053 ifn() {
1054 # insensitive find
1055 find -L . -not \( -name .svn -prune -o -name .git -prune \
1056 -o -name .hg -prune -o -name .editor-backups -prune \
1057 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
1058 }
1059
1060
1061 if [[ $OS == Windows_NT ]]; then
1062 # cygstart wrapper
1063 cs() {
1064 cygstart "$@" &
1065 }
1066 xp() {
1067 explorer.exe .
1068 }
1069 # launch
1070 o() {
1071 local x=(*$1*)
1072 (( ${#x[#]} > 1 )) && { echo "warning ${#x[#]} matches found"; sleep 1; }
1073 cygstart *$1* &
1074 }
1075 else
1076 o() {
1077 if type gvfs-open &> /dev/null ; then
1078 gvfs-open "$@"
1079 else
1080 xdg-open "$@"
1081 fi
1082 # another alternative is run-mailcap
1083 }
1084 fi
1085
1086 ipdrop() {
1087 s iptables -A INPUT -s $1 -j DROP
1088 }
1089
1090 jr() { journalctl "$@"; }
1091
1092 net-dev-info() {
1093 e "lspci -nnk|gr -iA2 net"
1094 lspci -nnk|gr -iA2 net
1095 hr
1096 e "s lshw -C network"
1097 hr
1098 s lshw -C network
1099
1100 }
1101
1102 istext() {
1103 grep -Il "" "$@" &>/dev/null
1104 }
1105
1106 jtail() {
1107 journalctl -n 10000 -f "$@" | grep -Evi "^(\S+\s+){4}(sudo|sshd|cron)"
1108 }
1109
1110 kff() { # keyboardio firmware flash
1111 pushd /a/bin/distro-setup/Arduino/Model01-Firmware
1112 yes $'\n' | make flash
1113 popd
1114 }
1115
1116 l() {
1117 if [[ $PWD == /[iap] ]]; then
1118 command ls -A --color=auto -I lost+found "$@"
1119 else
1120 command ls -A --color=auto "$@"
1121 fi
1122 }
1123
1124
1125 lcn() { locate -i "*$**"; }
1126
1127 lg() { LC_COLLATE=C.UTF-8 ll --group-directories-first; }
1128
1129 lt() { ll -tr "$@"; }
1130
1131 lld() { ll -d "$@"; }
1132
1133 lom() {
1134 local l base
1135 if [[ $1 == /* ]]; then
1136 base=${1##*/}
1137 if mountpoint /mnt/$base; then
1138 return 0
1139 fi
1140 l=$(sudo losetup -f)
1141 sudo losetup $l $1
1142 if ! sudo cryptsetup luksOpen $l $base; then
1143 sudo losetup -d $l
1144 return 1
1145 fi
1146 sudo mkdir -p /mnt/$base
1147 sudo mount /dev/mapper/$base /mnt/$base
1148 sudo chown $USER:$USER /mnt/$base
1149 else
1150 base=$1
1151 sudo umount /mnt/$base
1152 l=$(sudo cryptsetup status /dev/mapper/$base|sed -rn 's/^\s*device:\s*(.*)/\1/p')
1153 sudo cryptsetup luksClose /dev/mapper/$base || return 1
1154 sudo losetup -d $l
1155 fi
1156 }
1157
1158 low() { # make filenames lowercase, remove bad chars
1159 local f new
1160 for f in "$@"; do
1161 new="${f,,}" # downcase
1162 new="${new//[^[:alnum:]._-]/_}" # sub bad chars
1163 new="${new#"${new%%[[:alnum:]]*}"}" # remove leading/trailing non-alnum
1164 new="${new%"${new##*[[:alnum:]]}"}"
1165 # remove bad underscores, like __ and _._
1166 new=$(echo $new | sed -r 's/__+/_/g;s/_+([.-])|([.-])_+/\1/g')
1167 safe_rename "$f" "$new" || return 1
1168 done
1169 return 0
1170 }
1171
1172 lower() { # make first letter of filenames lowercase.
1173 local x
1174 for x in "$@"; do
1175 if [[ ${x::1} == [A-Z] ]]; then
1176 y=$(tr "[A-Z]" "[a-z]" <<<"${x::1}")"${x:1}"
1177 safe_rename "$x" "$y" || return 1
1178 fi
1179 done
1180 }
1181
1182
1183 k() { # history search
1184 grep -P --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | tail -n 80;
1185 }
1186
1187 ks() { # history search
1188 grep -P --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | uniq;
1189 }
1190
1191
1192 make-targets() {
1193 # show make targets, via http://stackoverflow.com/questions/3063507/list-goals-targets-in-gnu-make
1194 make -qp | awk -F':' '/^[a-zA-Z0-9][^$#\/\t=]*:([^=]|$)/ {split($1,A,/ /);for(i in A)print A[i]}'
1195 }
1196
1197 mbenable() {
1198 mb=$1
1199 dst=/m/4e/$1
1200 src=/m/md/$1
1201 set -x
1202 [[ -e $src ]] || { set +x; return 1; }
1203 mv -T $src $dst || { set +x; return 1; }
1204 ln -s -T $dst $src
1205 /a/exe/lnf /p/.mu ~
1206 mu index --maildir=/m/4e
1207 set +x
1208 }
1209 mbdisable() {
1210 mb=$1
1211 dst=/m/md/$1
1212 src=/m/4e/$1
1213 set -x
1214 [[ -e $src ]] || { set +x; return 1; }
1215 if [[ -L $dst ]]; then rm $dst; fi
1216 mv -T $src $dst
1217 set +x
1218 }
1219
1220
1221 mdt() {
1222 markdown "$1" >/tmp/mdtest.html
1223 firefox /tmp/mdtest.html
1224 }
1225
1226
1227 mkc() {
1228 mkdir "$1"
1229 c "$1"
1230 }
1231
1232 mkct() {
1233 mkc `mktemp -d`
1234 }
1235
1236 mkt() { # mkdir and touch file
1237 local path="$1"
1238 mkdir -p "$(dirname "$path")"
1239 touch "$path"
1240 }
1241
1242 mkdir() { command mkdir -p "$@"; }
1243
1244 mo() { xset dpms force off; } # monitor off
1245
1246
1247 nopanic() {
1248 sudo tee -a /var/log/exim4/paniclog-archive </var/log/exim4/paniclog; sudo truncate -s0 /var/log/exim4/paniclog
1249 }
1250
1251
1252 otp() {
1253 oathtool --totp -b "$@" | xclip -selection clipboard
1254 }
1255
1256 p8() { ping 8.8.8.8; }
1257
1258 pakaraoke() {
1259 # from http://askubuntu.com/questions/456021/remove-vocals-from-mp3-and-get-only-instrumentals
1260 pactl load-module module-ladspa-sink sink_name=Karaoke master=alsa_output.usb-Audioengine_Audioengine_D1-00.analog-stereo plugin=karaoke_1409 label=karaoke control=-30
1261 }
1262
1263
1264 pfind() { #find *$1* in $PATH
1265 [[ $# != 1 ]] && { echo requires 1 argument; return 1; }
1266 local pathArray
1267 IFS=: pathArray=($PATH); unset IFS
1268 find "${pathArray[@]}" -iname "*$1*"
1269 }
1270
1271 pk1() {
1272 local pid
1273 pid=($(pgrep -f "$*"))
1274 case ${#pid[@]} in
1275 1)
1276 ps -F $pid
1277 m kill $pid
1278 ;;
1279 0) echo "no pid found" ;;
1280 *)
1281 ps -F ${pid[@]}
1282 ;;
1283 esac
1284 }
1285
1286 pick-trash() {
1287 # trash-restore lists everything that has been trashed at or below CWD
1288 # This picks out files just in CWD, not subdirectories,
1289 # which also match grep $1, usually use $1 for a time string
1290 # which you get from running restore-trash once first
1291 local name x ask
1292 local nth=1
1293 # last condition is to not ask again for ones we skipped
1294 while name="$( echo | restore-trash | gr "$PWD/[^/]\+$" | gr "$1" )" \
1295 && [[ $name ]] && (( $(wc -l <<<"$name") >= nth )); do
1296 name="$(echo "$name" | head -n $nth | tail -n 1 )"
1297 read -p "$name [Y/n] " ask
1298 if [[ ! $ask || $ask == [Yy] ]]; then
1299 x=$( echo "$name" | gr -o "^\s*[0-9]*" )
1300 echo $x | restore-trash > /dev/null
1301 elif [[ $ask == [Nn] ]]; then
1302 nth=$((nth+1))
1303 else
1304 return
1305 fi
1306 done
1307 }
1308
1309
1310 pub() {
1311 rld /a/h/_site/ li:/var/www/iankelling.org/html
1312 }
1313
1314 pubip() { curl -4s https://icanhazip.com; }
1315 pubip6() { curl -6s https://icanhazip.com; }
1316 whatismyip() { pubip; }
1317
1318 pumpa() {
1319 # fixes the menu bar in xmonad. this won\'t be needed when xmonad
1320 # packages catches up on some changes in future (this is written in
1321 # 4/2017)
1322 #
1323 # geekosaur: so youll want to upgrade to xmonad 0.13 or else use a
1324 # locally modified XMonad.Hooks.ManageDocks that doesnt set the
1325 # work area; turns out it\'s impossible to set correctly if you are
1326 # not a fully EWMH compliant desktop environment
1327 #
1328 # geekosaur: chrome shows one failure mode, qt/kde another, other
1329 # gtk apps a third, ... I came up with a setting that works for me
1330 # locally but apparently doesnt work for others, so we joined the
1331 # other tiling window managers in giving up on setting it at all
1332 #
1333 xprop -root -remove _NET_WORKAREA
1334 command pumpa &r
1335 }
1336
1337
1338 pwgen() {
1339 # -m = min length
1340 # -x = max length
1341 # -t = print pronunciation
1342 apg -m 14 -x 17 -t
1343 for (( i=0; i<10; i++ )); do
1344 shuf -n3 /usr/share/hunspell/en_US.dic | sed 's,/.*,,' | paste -sd . -
1345
1346 done
1347 }
1348
1349 pwlong() {
1350 # -M CLN = use Caps, Lowercase, Numbers
1351 # -n 1 = 1 password
1352 # -a 1 = use random instead of pronounceable algorithm
1353 apg -m 50 -x 70 -n 1 -a 1 -M CLN
1354 }
1355
1356
1357 q() { # start / launch a program in the backround and redir output to null
1358 "$@" &> /dev/null &
1359 }
1360
1361 r() {
1362 exit "$@" 2>/dev/null
1363 }
1364
1365 rbpipe() { rbt post -o --diff-filename=- "$@"; }
1366 rbp() { rbt post -o "$@"; }
1367
1368 rl() {
1369 # rsync, root is required to keep permissions right.
1370 # rsync --archive --human-readable --verbose --itemize-changes --checksum \(-ahvic\) \
1371 # --no-times --delete
1372 # basically, make an exact copy, use checksums instead of file times to be more accurate
1373 rsync -ahvic --delete "$@"
1374 }
1375 rld() {
1376 # like rlu, but dont delete files on the target end which
1377 # do not exist on the original end.
1378 rsync -ahvic "$@"
1379 }
1380 complete -F _rsync -o nospace rld rl rlt
1381
1382 rlt() {
1383 # rl without preserving modification time.
1384 rsync -ahvic --delete --no-t "$@"
1385 }
1386
1387 rlu() { # [OPTS] HOST PATH
1388 # eg. rlu -opts frodo /testpath
1389 # relative paths will expanded with readlink -f.
1390 # useful for selectively sending dirs which have been synced with unison,
1391 # where the path is the same on both hosts.
1392 opts=("${@:1:$#-2}") # 1 to last -2
1393 path="${@:$#}" # last
1394 host="${@:$#-1:1}" # last -1
1395 if [[ $path == .* ]]; then
1396 path=$(readlink -f $path)
1397 fi
1398 # rync here uses checksum instead of time so we dont mess with
1399 # unison relying on time as much. g is for group, same reason
1400 # to keep up with unison.
1401 s rsync -rlpchviog --relative "${opts[@]}" "$path" "root@$host:/";
1402 }
1403
1404 # only run on MAIL_HOST. simpler to keep this on one system.
1405 r2eadd() { # usage: name url
1406 # initial setup of rss2email:
1407 # r2e new r2e@iankelling.org
1408 # that initializes files, and sets default email.
1409 # symlink to the config doesnt work, so I copied it to /p/c
1410 # and then use cli option to specify explicit path.
1411 # Only option changed from default config is to set
1412 # force-from = True
1413 #
1414 # or else for a few feeds, the from address is set by the feed, and
1415 # if I fail delivery, then I send a bounce message to that from
1416 # address, which makes me be a spammer.
1417
1418 r2e add $1 "$2" $1@r2e.iankelling.org
1419 # get up to date and dont send old entries now:
1420 r2e run --no-send $1
1421 }
1422 r2e() { command r2e -d /p/c/rss2email.json -c /p/c/rss2email.cfg "$@"; }
1423
1424 rspicy() { # usage: HOST DOMAIN
1425 # connect to spice vm remote host. use vspicy for local host
1426 local port=$(ssh $1<<EOF
1427 sudo virsh dumpxml $2|grep "<graphics.*type='spice'" | \
1428 sed -rn "s/.*port='([0-9]+).*/\1/p"
1429 EOF
1430 )
1431 if [[ $port ]]; then
1432 spicy -h $1 -p $port
1433 else
1434 echo "error: no port found. check that the domain is running."
1435 fi
1436 }
1437
1438 rmstrips() {
1439 ssh fencepost head -n 300 /gd/gnuorg/EventAndTravelInfo/rms-current-trips.txt | less
1440 }
1441
1442 s() {
1443 # background
1444 # I use a function because otherwise we cant use in a script,
1445 # cant assign to variable.
1446 #
1447 # note: gksudo is recommended for X apps because it does not set the
1448 # home directory to the same, and thus apps writing to ~ fuck things up
1449 # with root owned files.
1450 #
1451 if [[ $EUID != 0 || $1 == -* ]]; then
1452 SUDOD="$PWD" sudo -i "$@"
1453 else
1454 "$@"
1455 fi
1456 }
1457
1458 safe_rename() { # warn and dont rename if file exists.
1459 # mv -n exists, but it\'s silent
1460 if [[ $# != 2 ]]; then
1461 echo safe_rename error: $# args, need 2 >2
1462 return 1
1463 fi
1464 if [[ $1 != $2 ]]; then # yes, we want to silently ignore this
1465 if [[ -e $2 || -L $2 ]]; then
1466 echo "Cannot rename $1 to $2 as it already exists."
1467 else
1468 mv -vi "$1" "$2"
1469 fi
1470 fi
1471 }
1472
1473
1474 sb() { # sudo bash -c
1475 # use sb instead of s is for sudo redirections,
1476 # eg. sb 'echo "ok fine" > /etc/file'
1477 local SUDOD="$PWD"
1478 sudo -i bash -c "$@"
1479 }
1480 complete -F _root_command s sb
1481
1482 scssl() {
1483 # s gem install scss-lint
1484 pushd /a/opt/thoughtbot-guides
1485 git pull --stat
1486 popd
1487 scss-lint -c /a/opt/thoughtbot-guides/style/sass/.scss-lint.yml "$@"
1488 }
1489
1490 ser() {
1491 local s; [[ $EUID != 0 ]] && s=s
1492 if type -p systemctl &>/dev/null; then
1493 $s systemctl $1 $2
1494 else
1495 $s service $2 $1
1496 fi
1497 }
1498 # like restart, but do nothing if its not already started
1499 srestart() {
1500 local service=$1
1501 if [[ $(s systemctl --no-pager show -p ActiveState $service ) == ActiveState=active ]]; then
1502 systemctl restart $service
1503 fi
1504 }
1505 serstopnm() {
1506 ser stop NetworkManager
1507 ser stop dnsmasq
1508 s resolvconf -d NetworkManager
1509 ser start dnsmasq
1510 }
1511
1512 setini() { # set a value in a .ini style file
1513 key="$1" value="$2" section="$3" file="$4"
1514 if [[ -s $file ]]; then
1515 sed -ri -f - "$file" <<EOF
1516 # remove existing keys
1517 / *\[$section\]/,/^ *\[[^]]+\]/{/^\s*$key[[:space:]=]/d}
1518 # add key
1519 /^\s*\[$section\]/a $key=$value
1520 # from section to eof, do nothing
1521 /^\s*\[$section\]/,\$b
1522 # on the last line, if we haven't found section yet, add section and key
1523 \$a [$section]\\
1524 $key=$value
1525 EOF
1526 else
1527 cat >"$file" <<EOF
1528 [$section]
1529 $key=$value
1530 EOF
1531 fi
1532 }
1533
1534 sgo() { # service go
1535 service=$1
1536 ser restart $service || return 1
1537 if type -p systemctl &>/dev/null; then
1538 ser enable $service
1539 fi
1540 }
1541
1542
1543 shellck() {
1544 # 2086 = unquoted $var
1545 # 2046 = unquoted $(cmd)
1546 # i had -x as an arg, but debian testing(stretch) doesn\'t support it
1547 shellcheck -e 2086,2046,2068,2006,2119 "$@"
1548 }
1549
1550 skaraoke() {
1551 local tmp out
1552 in="$1"
1553 out=${2:-${1%.*}.sh}
1554 tmp=$(mktemp -d)
1555 script -t -c "mpv --no-config --no-resume-playback --no-terminal --no-audio-display '$1'" $tmp/typescript 2>$tmp/timing
1556 # todo, the current sleep seems pretty good, but it
1557 # would be nice to have an empirical measurement, or
1558 # some better wait to sync up.
1559 #
1560 # note: --loop-file=no prevents it from hanging if you have that
1561 # set to inf the mpv config.
1562 # --loop=no prevents it from exit code 3 due to stdin if you
1563 # had it set to inf in mpv config.
1564 #
1565 # args go to mpv, for example --volume=80, 50%
1566 cat >$out <<EOFOUTER
1567 #!/bin/bash
1568 trap "trap - TERM && kill 0" INT TERM ERR; set -e
1569 ( sleep .2; scriptreplay <( cat <<'EOF'
1570 $(cat $tmp/timing)
1571 EOF
1572 ) <( cat <<'EOF'
1573 $(cat $tmp/typescript)
1574 EOF
1575 ))&
1576 base64 -d - <<'EOF'| mpv --loop=no --loop-file=no --no-terminal --no-audio-display "\$@" -
1577 $(base64 "$1")
1578 EOF
1579 kill 0
1580 EOFOUTER
1581 rm -r $tmp
1582 chmod +x $out
1583 }
1584
1585 slog() {
1586 # log with script. timing is $1.t and script is $1.s
1587 # -l to save to ~/typescripts/
1588 # -t to add a timestamp to the filenames
1589 local logdir do_stamp arg_base
1590 (( $# >= 1 )) || { echo "arguments wrong"; return 1; }
1591 logdir="/a/dt/"
1592 do_stamp=false
1593 while getopts "lt" option
1594 do
1595 case $option in
1596 l ) arg_base=$logdir ;;
1597 t ) do_stamp=true ;;
1598 esac
1599 done
1600 shift $(($OPTIND - 1))
1601 arg_base+=$1
1602 [[ -e $logdir ]] || mkdir -p $logdir
1603 $do_stamp && arg_base+=$(date +%F.%T%z)
1604 script -t $arg_base.s 2> $arg_base.t
1605 }
1606 splay() { # script replay
1607 #logRoot="$HOME/typescripts/"
1608 #scriptreplay "$logRoot$1.t" "$logRoot$1.s"
1609 scriptreplay "$1.t" "$1.s"
1610 }
1611
1612 smeld() { # usage host1 host2 file
1613 meld <(ssh $1 cat $3) <(ssh $2 cat $3)
1614 }
1615
1616 spd() {
1617 PATH=/usr/local/spdhackfix:$PATH command spd "$@"
1618 }
1619
1620 spend() {
1621 s systemctl suspend
1622 }
1623
1624 sr() {
1625 # sudo redo. be aware, this command may not work right on strange distros or earlier software
1626 if [[ $# == 0 ]]; then
1627 sudo -E bash -c -l "$(history -p '!!')"
1628 else
1629 echo this command redos last history item. no argument is accepted
1630 fi
1631 }
1632
1633 srm () {
1634 # with -ll, less secure but faster.
1635 command srm -ll "$@"
1636 }
1637
1638 srun() {
1639 scp $2 $1:/tmp
1640 ssh $1 /tmp/${2##*/} "${@:2}"
1641 }
1642
1643 sss() { # ssh solo
1644 ssh -oControlMaster=no -oControlPath=/ "$@"
1645 }
1646 ssk() {
1647 local -a opts=()
1648 while [[ $1 == -* ]]; do
1649 opts+=("$1")
1650 shift
1651 done
1652 m pkill -f "^ssh: /tmp/ssh_mux_${USER}_${1#*@}_22_"
1653 m ssh "${opts[@]}" "$@"
1654 }
1655
1656 swap() {
1657 local tmp
1658 tmp=$(mktemp)
1659 mv $1 $tmp
1660 mv $2 $1
1661 mv $tmp $2
1662 }
1663
1664 t() {
1665 local x
1666 local -a args
1667 if type -t trash-put >/dev/null; then
1668 # skip args that dont exist, or else trash-put will have an error
1669 for x in "$@"; do
1670 if [[ -e $x || -L $x ]]; then
1671 args+=("$x")
1672 fi
1673 done
1674 [[ ! ${args[@]} ]] || trash-put "${args[@]}"
1675 else
1676 rm -rf "$@"
1677 fi
1678 }
1679
1680
1681 tclock() {
1682 clear
1683 date +%l:%_M
1684 len=60
1685 # this goes to full width
1686 #len=${1:-$((COLUMNS -7))}
1687 x=1
1688 while true; do
1689 if (( x == len )); then
1690 end=true
1691 d="$(date +%l:%_M) "
1692 else
1693 end=false
1694 d=$(date +%l:%M:%_S)
1695 fi
1696 echo -en "\r"
1697 echo -n "$d"
1698 for ((i=0; i<x; i++)); do
1699 if (( i % 6 )); then
1700 echo -n _
1701 else
1702 echo -n .
1703 fi
1704 done
1705 if $end; then
1706 echo
1707 x=1
1708 else
1709 x=$((x+1))
1710 fi
1711 sleep 5
1712 done
1713 }
1714
1715
1716 te() {
1717 # test existence / exists
1718 local ret=0
1719 for x in "$@"; do
1720 [[ -e "$x" || -L "$x" ]] || ret=1
1721 done
1722 return $ret
1723 }
1724
1725 # mail related
1726 testmail() {
1727 declare -gi _seq; _seq+=1
1728 echo "test body" | m mail -s "test mail from $HOSTNAME, $_seq" "${@:-root@localhost}"
1729 # for testing to send from an external address, you can do for example
1730 # -fian@iank.bid -aFrom:ian@iank.bid web-6fnbs@mail-tester.com
1731 # note in exim, you can retry a deferred message
1732 # s exim -M MSG_ID
1733 # MSG_ID is in /var/log/exim4/mainlog, looks like 1ccdnD-0001nh-EN
1734 }
1735
1736 # to test sieve, use below command. for fsf mail, see fsf-get-mail script.
1737 # make modifications, then copy to live file, use -eW to actually modify mailbox
1738 # cp /p/c/subdir_files/sieve/personal{test,}.sieve; testsievelist -eW INBOX
1739 #
1740 # Another option is to use sieve-test SCRIPT MAIL_FILE. note,
1741 # sieve-test doesnt know about envelopes, Im not sure if sieve-filter does.
1742
1743 # sieve with output filter. arg is mailbox, like INBOX.
1744 # This depends on dovecot conf, notably mail_location in /etc/dovecot/conf.d/10-mail.conf
1745
1746 testsievelist() {
1747 sieve-filter ~/sieve/maintest.sieve "$@" >/tmp/testsieve.log 2> >(tail) && sed -rn '/^Performed actions:/{n;n;p}' /tmp/testsieve.log | sort -u
1748 }
1749
1750
1751 # mail related
1752 # plain sieve
1753 testsieve() {
1754 sieve-filter ~/sieve/main.sieve "$@"
1755 }
1756
1757 # mail related
1758 testexim() {
1759 # testmail above calls sendmail, which is a link to exim/postfix.
1760 # its docs dont say a way of adding an argument
1761 # to sendmail to turn on debug output. We could make a wrapper, but
1762 # that is a pain. Exim debug args are documented here:
1763 # http://www.exim.org/exim-html-current/doc/html/spec_html/ch-the_exim_command_line.html
1764 #
1765 # http://www.exim.org/exim-html-current/doc/html/spec_html/ch-building_and_installing_exim.html
1766 # note, for exim daemon, you can turn on debug options by
1767 # adding -d, etc to COMMONOPTIONS in
1768 # /etc/default/exim4
1769 exim -d -t <<'EOF'
1770 From: ian@iankelling.org
1771 To: root@lists0p.fsf.org
1772 Subject: Testing Exim
1773
1774 This is a test message.
1775 EOF
1776 }
1777
1778 # toggle keyboard
1779 tk() {
1780 # based on
1781 # https://askubuntu.com/questions/160945/is-there-a-way-to-disable-a-laptops-internal-keyboard
1782 id=$(xinput --list --id-only 'AT Translated Set 2 keyboard')
1783 if xinput list | grep -F '∼ AT Translated Set 2 keyboard' &>/dev/null; then
1784 echo enabling keyboard
1785 # find the first slave keyboard number, they are all the same in my output.
1786 # if they werent, worst case we would need to save the slave number somewhere
1787 # when it got disabled.
1788 slave=$(xinput list | sed -n 's/.*slave \+keyboard (\([0-9]*\)).*/\1/p' | head -n1)
1789 xinput reattach $id $slave
1790 else
1791 xinput float $id
1792 fi
1793 }
1794
1795 tm() {
1796 # timer in minutes
1797 # --no-config
1798 (sleep $(calc "$@ * 60") && mpv --no-config --volume 50 /a/bin/data/alarm.mp3) > /dev/null 2>&1 &
1799 }
1800
1801 trg() { transmission-remote-gtk&r; }
1802 trc() {
1803 # example, set global upload limit to 100 kilobytes:
1804 # trc -u 100
1805 TR_AUTH=":$(jq -r .profiles[0].password ~/.config/transmission-remote-gtk/config.json)" transmission-remote transmission.lan -ne "$@"
1806 }
1807
1808
1809 tu() {
1810 local s;
1811 local dir="$(dirname "$1")"
1812 if [[ -e $1 && ! -w $1 || ! -w $(dirname "$1") ]]; then
1813 s=s;
1814 fi
1815 $s teeu "$@"
1816 }
1817
1818 tx() { # toggle set -x, and the prompt so it doesnt spam
1819 if [[ $- == *x* ]]; then
1820 set +x
1821 PROMPT_COMMAND=prompt-command
1822 # disabled due to issue on stretch, running ll we get error. something
1823 # about the DEBUG trap is broken
1824 # if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
1825 # trap 'settitle "$BASH_COMMAND"' DEBUG
1826 # fi
1827 else
1828 # normally, i would just execute these commands in the function.
1829 # however, DEBUG is not inherited, so we need to run it outside a function.
1830 # And we want to run set -x afterwards to avoid spam, so we cram everything
1831 # in here, and then it will run after this function is done.
1832 #PROMPT_COMMAND='trap DEBUG; unset PROMPT_COMMAND; PS1="\w \$ "; set -x'
1833
1834 unset PROMPT_COMMAND
1835 PS1="\w \$ "
1836 set -x
1837 fi
1838 }
1839
1840 psnetns() {
1841 # show all processes in the network namespace $1.
1842 # blank entries appear to be subprocesses/threads
1843 local x netns
1844 netns=$1
1845 ps -w | head -n 1
1846 s find -L /proc/[1-9]*/task/*/ns/net -samefile /run/netns/$netns | cut -d/ -f5 | \
1847 while read l; do
1848 x=$(ps -w --no-headers -p $l);
1849 if [[ $x ]]; then echo "$x"; else echo $l; fi;
1850 done
1851 }
1852
1853 m() { printf "%s\n" "$*"; "$@"; }
1854
1855
1856 vpncmd() {
1857 #m s nsenter -t $(pgrep -f "/usr/sbin/openvpn .* --config /etc/openvpn/.*pia.conf") -n -m "$@"
1858 m s nsenter -t $(pgrep -f "/usr/sbin/openvpn .* --config /etc/openvpn/.*client.conf") -n -m "$@"
1859 }
1860 vpnf() {
1861 vpncmd gksudo -u iank "firefox -no-remote -P vpn" &r
1862 }
1863 vpni() {
1864 vpncmd gksudo -u iank "$*"
1865 }
1866 vpnbash() {
1867 vpncmd bash
1868 }
1869
1870
1871
1872 virshrm() {
1873 for x in "$@"; do virsh destroy "$x"; virsh undefine "$x"; done
1874 }
1875
1876 vm-set-listen(){
1877 local t=$(mktemp)
1878 local vm=$1
1879 local ip=$2
1880 s virsh dumpxml $vm | sed -r "s/(<listen.*address=')([^']+)/\1$ip/" | \
1881 sed -r "s/listen='[^']+/listen='$ip/"> $t
1882 s virsh undefine $vm
1883 s virsh define $t
1884 }
1885
1886
1887 vmshare() {
1888 vm-set-listen $1 0.0.0.0
1889 }
1890
1891
1892 vmunshare() {
1893 vm-set-listen $1 127.0.0.1
1894 }
1895
1896
1897 vpn() {
1898 if [[ -e /lib/systemd/system/openvpn-client@.service ]]; then
1899 local vpn_service=openvpn-client
1900 else
1901 local vpn_service=openvpn
1902 fi
1903
1904 [[ $1 ]] || { echo need arg; return 1; }
1905 journalctl --unit=$vpn_service@$1 -f -n0 &
1906 s systemctl start $vpn_service@$1
1907 # sometimes the ask-password agent does not work and needs a delay.
1908 sleep .5
1909 # https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=779240
1910 # noticed around 8-2017 after update from around stretch release
1911 # on debian testing, even though the bug is much older.
1912 s systemd-tty-ask-password-agent
1913 }
1914
1915 vpnoff() {
1916 [[ $1 ]] || { echo need arg; return 1; }
1917 if [[ -e /lib/systemd/system/openvpn-client@.service ]]; then
1918 local vpn_service=openvpn-client
1919 else
1920 local vpn_service=openvpn
1921 fi
1922 s systemctl stop $vpn_service@$1
1923 }
1924
1925
1926 vrm() {
1927 virsh destroy $1
1928 virsh undefine $1
1929 }
1930
1931
1932
1933 vspicy() { # usage: VIRSH_DOMAIN
1934 # connect to vms made with virt-install
1935 spicy -p $(sudo virsh dumpxml "$1"|grep "<graphics.*type='spice'"|\
1936 sed -r "s/.*port='([0-9]+).*/\1/")
1937 }
1938
1939 wian() {
1940 cat-new-files /m/4e/INBOX/new
1941 }
1942
1943 wtr() { curl wttr.in/boston; }
1944
1945 xl() {
1946 if pgrep gnome-screensav &>/dev/null; then
1947 # this command actually starts gnome-screensaver if it isn\'t running.
1948 # lololol, what crap
1949 gnome-screensaver-command --exit &>/dev/null
1950 fi
1951 mate-screensaver-command --exit &>/dev/null
1952 if ! pidof xscreensaver; then
1953 pushd /
1954 xscreensaver &
1955 popd
1956 # 1 was not long enough
1957 sleep 3
1958 fi
1959 xscreensaver-command -activate
1960 }
1961
1962 # * misc stuff
1963
1964 # from curl cheat.sh/:bash_completion
1965 _cheatsh_complete_curl()
1966 {
1967 local cur prev opts
1968 _get_comp_words_by_ref -n : cur
1969
1970 COMPREPLY=()
1971 #cur="${COMP_WORDS[COMP_CWORD]}"
1972 prev="${COMP_WORDS[COMP_CWORD-1]}"
1973 opts="$(curl -s cheat.sh/:list | sed s@^@cheat.sh/@)"
1974
1975 if [[ ${cur} == cheat.sh/* ]] ; then
1976 COMPREPLY=( $(compgen -W "${opts}" -- ${cur}) )
1977 __ltrim_colon_completions "$cur"
1978 return 0
1979 fi
1980 }
1981 complete -F _cheatsh_complete_curl curl
1982
1983
1984 if [[ $- == *i* ]]; then
1985 # commands to run when bash exits normally
1986 trap "hl" EXIT
1987 fi
1988
1989
1990 # temporary variables to test colorization
1991 # some copied from gentoo /etc/bash/bashrc,
1992 use_color=false
1993 # dircolors --print-database uses its own built-in database
1994 # instead of using /etc/DIR_COLORS. Try to use the external file
1995 # first to take advantage of user additions.
1996 safe_term=${TERM//[^[:alnum:]]/?} # sanitize TERM
1997 match_lhs=""
1998 [[ -f ~/.dir_colors ]] && match_lhs="${match_lhs}$(<~/.dir_colors)"
1999 [[ -f /etc/DIR_COLORS ]] && match_lhs="${match_lhs}$(</etc/DIR_COLORS)"
2000 [[ -z ${match_lhs} ]] \
2001 && type -P dircolors >/dev/null \
2002 && match_lhs=$(dircolors --print-database)
2003 # test if our $TERM is in the TERM values in dircolor
2004 [[ $'\n'${match_lhs} == *$'\n'"TERM "${safe_term}* ]] && use_color=true
2005
2006
2007 if ${use_color} && [[ $- == *i* ]]; then
2008
2009 if [[ $XTERM_VERSION == Cygwin* ]]; then
2010 get_term_color() {
2011 for x in "$@"; do
2012 case $x in
2013 underl) echo -n $'\E[4m' ;;
2014 bold) echo -n $'\E[1m' ;;
2015 red) echo -n $'\E[31m' ;;
2016 green) echo -n $'\E[32m' ;;
2017 blue) echo -n $'\E[34m' ;;
2018 cyan) echo -n $'\E[36m' ;;
2019 yellow) echo -n $'\E[33m' ;;
2020 purple) echo -n $'\E[35m' ;;
2021 nocolor) echo -n $'\E(B\E[m' ;;
2022 esac
2023 done
2024 }
2025
2026 else
2027 get_term_color() {
2028 for x in "$@"; do
2029 case $x in
2030 underl) echo -n $(tput smul) ;;
2031 bold) echo -n $(tput bold) ;;
2032 red) echo -n $(tput setaf 1) ;;
2033 green) echo -n $(tput setaf 2) ;;
2034 blue) echo -n $(tput setaf 4) ;;
2035 cyan) echo -n $(tput setaf 6) ;;
2036 yellow) echo -n $(tput setaf 3) ;;
2037 purple) echo -n $(tput setaf 5) ;;
2038 nocolor) echo -n $(tput sgr0) ;; # no font attributes
2039 esac
2040 done
2041 }
2042 fi
2043 else
2044 get_term_color() {
2045 :
2046 }
2047 fi
2048 # Try to keep environment pollution down, EPA loves us.
2049 unset safe_term match_lhs use_color
2050
2051
2052
2053 # * prompt
2054
2055
2056 if [[ $- == *i* ]]; then
2057 # git branch/status prompt function
2058 if [[ $OS != Windows_NT ]]; then
2059 GIT_PS1_SHOWDIRTYSTATE=true
2060 fi
2061 # arch source lopip show -fcation
2062 [[ -r /usr/share/git/git-prompt.sh ]] && source /usr/share/git/git-prompt.sh
2063 # fedora/debian source
2064 [[ -r /usr/share/git-core/contrib/completion/git-prompt.sh ]] && source /usr/share/git-core/contrib/completion/git-prompt.sh
2065
2066 # in case we didnt source git-prompt.sh
2067 if ! declare -f __git_ps1 > /dev/null; then
2068 __git_ps1() {
2069 :
2070 }
2071 fi
2072
2073 # this needs to come before next ps1 stuff
2074 # this stuff needs bash 4, feb 2009,
2075 # old enough to no longer condition on $BASH_VERSION anymore
2076 shopt -s autocd
2077 shopt -s dirspell
2078 PS1='\w'
2079 if [[ $- == *i* ]] && [[ ! $RLC_INSIDE_EMACS ]]; then
2080 PROMPT_DIRTRIM=2
2081 bind -m vi-command B:shell-backward-word
2082 bind -m vi-command W:shell-forward-word
2083 fi
2084
2085 if [[ $SSH_CLIENT ]]; then
2086 PS1="\h $PS1"
2087 fi
2088
2089
2090
2091
2092 prompt-command() {
2093 local return=$? # this MUST COME FIRST
2094 local psc pst ps_char ps_color stale_subvol
2095 unset IFS
2096 history -a # save history
2097
2098
2099
2100 case $return in
2101 0) ps_color="$(get_term_color blue)"
2102 ps_char='\$'
2103 ;;
2104 1) ps_color="$(get_term_color green)"
2105 ps_char="$return \\$"
2106 ;;
2107 *) ps_color="$(get_term_color yellow)"
2108 ps_char="$return \\$"
2109 ;;
2110 esac
2111 if [[ ! -O . ]]; then # not owner
2112 if [[ -w . ]]; then # writable
2113 ps_color="$(get_term_color bold red)"
2114 else
2115 ps_color="$(get_term_color bold green)"
2116 fi
2117 fi
2118 # I would set nullglob, but bash has had bugs where that
2119 # doesnt work if not in top level.
2120 if [[ -e /nocow/btrfs-stale ]] && ((`command ls -AUq /nocow/btrfs-stale|wc -l`)); then
2121 ps_char="! $ps_char"
2122 fi
2123 PS1="${PS1%"${PS1#*[wW]}"} \[$ps_color\]$ps_char\[$(get_term_color nocolor)\] "
2124 # emacs completion doesnt like the git prompt atm, so disabling it.
2125 #PS1="${PS1%"${PS1#*[wW]}"}$(__git_ps1 ' (%s)') \[$ps_color\]$ps_char\[$(get_term_color nocolor)\] "
2126 }
2127 PROMPT_COMMAND=prompt-command
2128
2129 settitle () {
2130 if [[ $TERM == screen* ]]; then
2131 local title_escape="\033]..2;"
2132 else
2133 local title_escape="\033]0;"
2134 fi
2135 if [[ $* != prompt-command ]]; then
2136 echo -ne "$title_escape$USER@$HOSTNAME ${PWD/#$HOME/~} "
2137 printf "%s" "$*"
2138 echo -ne "\007"
2139 fi
2140 }
2141
2142 # for titlebar.
2143 # condition from the screen man page i think.
2144 # note: duplicated in tx()
2145 # disabled. see note in tx
2146 # if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
2147 # trap 'settitle "$BASH_COMMAND"' DEBUG
2148 # else
2149 # trap DEBUG
2150 # fi
2151
2152 fi
2153
2154 reset-konsole() {
2155 # we also have a file in /a/c/...konsole...
2156 local f=$HOME/.config/konsolerc
2157 setini DefaultProfile profileian.profile "Desktop Entry" $f
2158 setini Favorites profileian.profile "Favorite Profiles" $f
2159 setini ShowMenuBarByDefault false KonsoleWindow $f
2160 setini TabBarPosition Top TabBar $f
2161 }
2162
2163 reset-sakura() {
2164 while read k v; do
2165 setini $k $v sakura /a/c/subdir_files/.config/sakura/sakura.conf
2166 done <<'EOF'
2167 colorset1_back rgb(33,37,39
2168 less_questions true
2169 audible_bell No
2170 visible_bell No
2171 disable_numbered_tabswitch true
2172 scroll_lines 10000000
2173 scrollbar true
2174 EOF
2175 }
2176
2177 reset-xscreensaver() {
2178 # except for spash, i set these by setting gui options in
2179 # xscreensaver-command -demo
2180 # then finding the corresponding option in .xscreensaver
2181 # spash, i happened to notice in .xscreensaver
2182 #
2183 # dpmsOff, monitor doesnt come back on using old free software supported nvidia card
2184 cat > /home/iank/.xscreensaver <<'EOF'
2185 mode: blank
2186 dpmsEnabled: True
2187 dpmsStandby: 0:02:00
2188 dpmsSuspend: 0:03:00
2189 dpmsOff: 0:00:00
2190 timeout: 0:02:00
2191 lock: True
2192 lockTimeout: 0:03:00
2193 splash: False
2194 EOF
2195
2196 }
2197
2198
2199 # * stuff that makes sense to be at the end
2200 if [[ "$SUDOD" ]]; then
2201 cd "$SUDOD"
2202 unset SUDOD
2203 elif [[ -d /a ]] && [[ $PWD == $HOME ]] && [[ $- == *i* ]]; then
2204 cd /a
2205 fi
2206
2207
2208 # best practice
2209 unset IFS
2210
2211
2212 # for mitmproxy to get a newer python.
2213 # commented until i want to use it because it
2214 # noticably slows bash startup
2215 #
2216 #if [[ $EUID != 0 && -e ~/.pyenv/bin ]]; then
2217 # export PATH="~/.pyenv/bin:$PATH"
2218 # eval "$(pyenv init -)"
2219 # eval "$(pyenv virtualenv-init -)"
2220 #fi
2221
2222
2223
2224 export GOPATH=$HOME/go
2225 path_add $GOPATH/bin
2226 path_add /usr/local/go/bin
2227
2228 export ARDUINO_PATH=/a/opt/Arduino/build/linux/work
2229
2230 path_add --end ~/.npm-global
2231
2232 # taken from default changes to bashrc and bash_profile
2233 path_add --end $HOME/.rvm/bin
2234 [[ -s "$HOME/.rvm/scripts/rvm" ]] && source "$HOME/.rvm/scripts/rvm" # Load RVM into a shell session *as a function*
2235
2236 export BASEFILE_DIR=/a/bin/fai-basefiles
2237
2238 export ANDROID_HOME=/opt/android
2239
2240 # didnt get drush working, if I did, this seems like the
2241 # only good thing to include for it.
2242 # Include Drush completion.
2243 # if [ -f "/home/ian/.drush/drush.complete.sh" ] ; then
2244 # source /home/ian/.drush/drush.complete.sh
2245 # fi
2246
2247
2248 # https://wiki.archlinux.org/index.php/Xinitrc#Autostart_X_at_login
2249 # i added an extra condition as gentoo xorg guide says depending on
2250 # $DISPLAY is fragile.
2251 if [[ ! $DISPLAY && $XDG_VTNR == 1 ]] && shopt -q login_shell && isarch; then
2252 exec startx
2253 fi
2254
2255
2256 # ensure no bad programs appending to this file will have an affect
2257 return 0